
'===============================================================================
'  ** IMPORTANT  **
'  Template: Miranda x Vb.Net x SqlServer
'  Version : 1.3
'  Author  : Gianluca Pezzoli
'  Entity  : Tmp
'  Server  : 
'  DB      : Finanza
'  Table   : Tmp
'===============================================================================

Imports System
Imports System.ComponentModel
Imports Pezzoli.Data.Miranda

Namespace Titoli

   <TableMapping("TmpMsSql", "Tmp")> _
    Partial Public Class TmpMsSql
      Implements INotifyPropertyChanged, INotifyPropertyChanging

      ' Enum with Entity Properties binded to DB Table columns
      Public Enum LinkedProperties
         Col1
         Col2
         Col3
         Col4
         Col5
         Col6
         Col7
         Col8
      End Enum

      ' Private Table columns 
      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Col1 As Nullable(Of Boolean)

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Col2 As String

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Col3 As Nullable(Of Decimal)

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Col4 As Nullable(Of Single)

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Col5 As Nullable(Of DateTime)

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Col6 As Nullable(Of Short)

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Col7 As Nullable(Of Byte)

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Col8 As String



      Private Sub SetDefaultValuesForBindedProperties()
         _Col2 = Nothing
         _Col3 = Nothing
         _Col8 = Nothing
      End Sub

      Public Sub New()
         SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos
      End Sub


      '=================================================================
      '  Properties Generated from the Table                        
      '=================================================================
#Region "Properties"

      <ColumnMappingAttribute("Col1", "BIT", False, False, True, 0)> _
      Public Property Col1() As Nullable(Of Boolean)
         Get
            Return _Col1
         End Get
         Set(ByVal Value As Nullable(Of Boolean))
            Try
               _Col1 = Value
               OnPropertyChanged("Col1")
            Catch ex As System.Exception
               Throw New Exception("Error setting Col1", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Col2", "CHAR", False, False, True, 10)> _
      Public Property Col2() As String
         Get
            Return _Col2
         End Get
         Set(ByVal Value As String)
            Try
               If Value Is Nothing Then
                  _Col2 = Value
                  OnPropertyChanged("Col2")
               Else
                  If Value.Length <= 10 Then
                     _Col2 = Value
                     OnPropertyChanged("Col2")
                  Else
                     Throw New OverflowException("Error setting Col2, Length of Value is to long. Maximum Length: 10")
                  End If
               End If

            Catch ex As System.Exception
               Throw New Exception("Error setting Col2", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Col3", "NUMERIC", False, False, True, 0)> _
      Public Property Col3() As Nullable(Of Decimal)
         Get
            Return _Col3
         End Get
         Set(ByVal Value As Nullable(Of Decimal))
            Try
               _Col3 = Value
               OnPropertyChanged("Col3")
            Catch ex As System.Exception
               Throw New Exception("Error setting Col3", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Col4", "REAL", False, False, True, 0)> _
      Public Property Col4() As Nullable(Of Single)
         Get
            Return _Col4
         End Get
         Set(ByVal Value As Nullable(Of Single))
            Try
               _Col4 = Value
               OnPropertyChanged("Col4")
            Catch ex As System.Exception
               Throw New Exception("Error setting Col4", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Col5", "SMALLDATETIME", False, False, True, 0)> _
      Public Property Col5() As Nullable(Of DateTime)
         Get
            Return _Col5
         End Get
         Set(ByVal Value As Nullable(Of DateTime))
            Try
               _Col5 = Value
               OnPropertyChanged("Col5")
            Catch ex As System.Exception
               Throw New Exception("Error setting Col5", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Col6", "SMALLINT", False, False, True, 0)> _
      Public Property Col6() As Nullable(Of Short)
         Get
            Return _Col6
         End Get
         Set(ByVal Value As Nullable(Of Short))
            Try
               _Col6 = Value
               OnPropertyChanged("Col6")
            Catch ex As System.Exception
               Throw New Exception("Error setting Col6", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Col7", "TINYINT", False, False, True, 0)> _
      Public Property Col7() As Nullable(Of Byte)
         Get
            Return _Col7
         End Get
         Set(ByVal Value As Nullable(Of Byte))
            Try
               _Col7 = Value
               OnPropertyChanged("Col7")
            Catch ex As System.Exception
               Throw New Exception("Error setting Col7", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Col8", "VARCHAR", False, False, True, 50)> _
      Public Property Col8() As String
         Get
            Return _Col8
         End Get
         Set(ByVal Value As String)
            Try
               If Value Is Nothing Then
                  _Col8 = Value
                  OnPropertyChanged("Col8")
               Else
                  If Value.Length <= 50 Then
                     _Col8 = Value
                     OnPropertyChanged("Col8")
                  Else
                     Throw New OverflowException("Error setting Col8, Length of Value is to long. Maximum Length: 50")
                  End If
               End If

            Catch ex As System.Exception
               Throw New Exception("Error setting Col8", ex)
            End Try
         End Set
      End Property

#End Region

#Region "INotifyPropertyChanged"
      Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

      Protected Sub OnPropertyChanged(ByVal field As String)
         RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(field))
      End Sub
#End Region

#Region "INotifyPropertyChanging"
      Public Event PropertyChanging(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangingEventArgs) Implements System.ComponentModel.INotifyPropertyChanging.PropertyChanging

      Protected Sub OnPropertyChanging(ByVal field As String)
         RaiseEvent PropertyChanging(Me, New PropertyChangingEventArgs(field))
      End Sub
#End Region
   End Class
End Namespace