'===============================================================================
'  ** IMPORTANT  **
'  Template: Miranda x Vb.Net x SqlServer
'  Version : 1.3
'  Author  : Gianluca Pezzoli
'  Entity  : Valuta
'  Server  : 
'  DB      : Finanza
'  Table   : Valute
'===============================================================================

Imports System
Imports System.ComponentModel
Imports Pezzoli.Data.Miranda

Namespace Titoli

   <TableMapping("ValutaMsSql", "Valute")> _
    Partial Public Class ValutaMsSql
      Implements INotifyPropertyChanged, INotifyPropertyChanging

      ' Enum with Entity Properties binded to DB Table columns
      Public Enum LinkedProperties
         IDValuta
         Valuta
         Cambio
         Nome
      End Enum

      ' Private Table columns 
      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDValuta As Byte

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Valuta As String

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Cambio As Single

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Nome As String



      Private Sub SetDefaultValuesForBindedProperties()
         _Valuta = Nothing
         _Cambio = 1
         _Nome = Nothing
      End Sub

      Public Sub New()
         SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos
      End Sub


      '=================================================================
      '  Properties Generated from the Table                        
      '=================================================================
#Region "Properties"

      <ColumnMappingAttribute("IDValuta", "TINYINT", True, True, False, 0)> _
      Public ReadOnly Property IDValuta() As Byte
         Get
            Return _IDValuta
         End Get
      End Property

      <ColumnMappingAttribute("Valuta", "VARCHAR", False, False, False, 3)> _
      Public Property Valuta() As String
         Get
            Return _Valuta
         End Get
         Set(ByVal Value As String)
            Try
               If Value Is Nothing Then
                  _Valuta = Value
                  OnPropertyChanged("Valuta")
               Else
                  If Value.Length <= 3 Then
                     _Valuta = Value
                     OnPropertyChanged("Valuta")
                  Else
                     Throw New OverflowException("Error setting Valuta, Length of Value is to long. Maximum Length: 3")
                  End If
               End If

            Catch ex As System.Exception
               Throw New Exception("Error setting Valuta", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Cambio", "REAL", False, False, False, 0)> _
      Public Property Cambio() As Single
         Get
            Return _Cambio
         End Get
         Set(ByVal Value As Single)
            Try
               _Cambio = Value
               OnPropertyChanged("Cambio")
            Catch ex As System.Exception
               Throw New Exception("Error setting Cambio", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Nome", "VARCHAR", False, False, True, 12)> _
      Public Property Nome() As String
         Get
            Return _Nome
         End Get
         Set(ByVal Value As String)
            Try
               If Value Is Nothing Then
                  _Nome = Value
                  OnPropertyChanged("Nome")
               Else
                  If Value.Length <= 12 Then
                     _Nome = Value
                     OnPropertyChanged("Nome")
                  Else
                     Throw New OverflowException("Error setting Nome, Length of Value is to long. Maximum Length: 12")
                  End If
               End If

            Catch ex As System.Exception
               Throw New Exception("Error setting Nome", ex)
            End Try
         End Set
      End Property

#End Region

#Region "INotifyPropertyChanged"
      Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

      Protected Sub OnPropertyChanged(ByVal field As String)
         RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(field))
      End Sub
#End Region

#Region "INotifyPropertyChanging"
      Public Event PropertyChanging(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangingEventArgs) Implements System.ComponentModel.INotifyPropertyChanging.PropertyChanging

      Protected Sub OnPropertyChanging(ByVal field As String)
         RaiseEvent PropertyChanging(Me, New PropertyChangingEventArgs(field))
      End Sub
#End Region
   End Class
End Namespace