
'===============================================================================
'  ** IMPORTANT  **
'  Template: Miranda x Vb.Net x SqlServer
'  Version : 1.3
'  Author  : Gianluca Pezzoli
'  Entity  : Titolo
'  Server  : 
'  DB      : Finanza
'  Table   : Titoli
'===============================================================================

Imports System
Imports System.ComponentModel
Imports Pezzoli.Data.Miranda

Namespace Titoli

   <TableMapping("TitoloMsSql", "Titoli")> _
    Partial Public Class TitoloMsSql
      Implements INotifyPropertyChanged, INotifyPropertyChanging


      ' Private Table columns 
      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDTitolo As Integer

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _CodISIN As String

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Titolo As String

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDTipo As Byte

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _LottoMinimo As Nullable(Of Short)

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Data As Nullable(Of DateTime)

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Tassazione As Boolean

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _PercentualeAzioni As Byte

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Attivo As Boolean

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Scadenza As Nullable(Of DateTime)

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDSettore As Byte

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDAreaGeografica As Byte

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDCategoriaFondi As Byte

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Info As String

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDObiettivo As Byte

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDValutaSecondaria As Byte

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _IDValutaPrimaria As Byte

      <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
      Private _Emissione As Nullable(Of DateTime)



      Private Sub SetDefaultValuesForBindedProperties()
         _CodISIN = Nothing
         _Titolo = Nothing
         _IDTipo = 1
         _LottoMinimo = 1
         _Data = Nothing
         _Tassazione = 1
         _PercentualeAzioni = 0
         _Attivo = 1
         _Scadenza = Nothing
         _IDSettore = 1
         _IDAreaGeografica = 2
         _IDCategoriaFondi = 0
         _Info = Nothing
         _IDObiettivo = 0
         _IDValutaSecondaria = 1
         _IDValutaPrimaria = 1
         _Emissione = Nothing
      End Sub

      Public Sub New()
         SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos
      End Sub


      '=================================================================
      '  Properties Generated from the Table                        
      '=================================================================
#Region "Properties"

      <ColumnMappingAttribute("IDTitolo", "INT", True, True, False, 0)> _
      Public ReadOnly Property IDTitolo() As Integer
         Get
            Return _IDTitolo
         End Get
      End Property

      <ColumnMappingAttribute("CodISIN", "VARCHAR", False, False, True, 12)> _
      Public Property CodISIN() As String
         Get
            Return _CodISIN
         End Get
         Set(ByVal Value As String)
            Try
               If Value Is Nothing Then
                  _CodISIN = Value
                  OnPropertyChanged("CodISIN")
               Else
                  If Value.Length <= 12 Then
                     _CodISIN = Value
                     OnPropertyChanged("CodISIN")
                  Else
                     Throw New OverflowException("Error setting CodISIN, Length of Value is to long. Maximum Length: 12")
                  End If
               End If

            Catch ex As System.Exception
               Throw New Exception("Error setting CodISIN", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Titolo", "VARCHAR", False, False, True, 60)> _
      Public Property Titolo() As String
         Get
            Return _Titolo
         End Get
         Set(ByVal Value As String)
            Try
               If Value Is Nothing Then
                  _Titolo = Value
                  OnPropertyChanged("Titolo")
               Else
                  If Value.Length <= 60 Then
                     _Titolo = Value
                     OnPropertyChanged("Titolo")
                  Else
                     Throw New OverflowException("Error setting Titolo, Length of Value is to long. Maximum Length: 60")
                  End If
               End If

            Catch ex As System.Exception
               Throw New Exception("Error setting Titolo", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("IDTipo", "TINYINT", False, False, False, 0)> _
      Public Property IDTipo() As Byte
         Get
            Return _IDTipo
         End Get
         Set(ByVal Value As Byte)
            Try
               _IDTipo = Value
               OnPropertyChanged("IDTipo")
            Catch ex As System.Exception
               Throw New Exception("Error setting IDTipo", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("LottoMinimo", "SMALLINT", False, False, True, 0)> _
      Public Property LottoMinimo() As Nullable(Of Short)
         Get
            Return _LottoMinimo
         End Get
         Set(ByVal Value As Nullable(Of Short))
            Try
               _LottoMinimo = Value
               OnPropertyChanged("LottoMinimo")
            Catch ex As System.Exception
               Throw New Exception("Error setting LottoMinimo", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Data", "SMALLDATETIME", False, False, True, 0)> _
      Public Property Data() As Nullable(Of DateTime)
         Get
            Return _Data
         End Get
         Set(ByVal Value As Nullable(Of DateTime))
            Try
               _Data = Value
               OnPropertyChanged("Data")
            Catch ex As System.Exception
               Throw New Exception("Error setting Data", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Tassazione", "BIT", False, False, False, 0)> _
      Public Property Tassazione() As Boolean
         Get
            Return _Tassazione
         End Get
         Set(ByVal Value As Boolean)
            Try
               _Tassazione = Value
               OnPropertyChanged("Tassazione")
            Catch ex As System.Exception
               Throw New Exception("Error setting Tassazione", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("PercentualeAzioni", "TINYINT", False, False, False, 0)> _
      Public Property PercentualeAzioni() As Byte
         Get
            Return _PercentualeAzioni
         End Get
         Set(ByVal Value As Byte)
            Try
               _PercentualeAzioni = Value
               OnPropertyChanged("PercentualeAzioni")
            Catch ex As System.Exception
               Throw New Exception("Error setting PercentualeAzioni", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Attivo", "BIT", False, False, False, 0)> _
      Public Property Attivo() As Boolean
         Get
            Return _Attivo
         End Get
         Set(ByVal Value As Boolean)
            Try
               _Attivo = Value
               OnPropertyChanged("Attivo")
            Catch ex As System.Exception
               Throw New Exception("Error setting Attivo", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Scadenza", "SMALLDATETIME", False, False, True, 0)> _
      Public Property Scadenza() As Nullable(Of DateTime)
         Get
            Return _Scadenza
         End Get
         Set(ByVal Value As Nullable(Of DateTime))
            Try
               _Scadenza = Value
               OnPropertyChanged("Scadenza")
            Catch ex As System.Exception
               Throw New Exception("Error setting Scadenza", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("IDSettore", "TINYINT", False, False, False, 0)> _
      Public Property IDSettore() As Byte
         Get
            Return _IDSettore
         End Get
         Set(ByVal Value As Byte)
            Try
               _IDSettore = Value
               OnPropertyChanged("IDSettore")
            Catch ex As System.Exception
               Throw New Exception("Error setting IDSettore", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("IDAreaGeografica", "TINYINT", False, False, False, 0)> _
      Public Property IDAreaGeografica() As Byte
         Get
            Return _IDAreaGeografica
         End Get
         Set(ByVal Value As Byte)
            Try
               _IDAreaGeografica = Value
               OnPropertyChanged("IDAreaGeografica")
            Catch ex As System.Exception
               Throw New Exception("Error setting IDAreaGeografica", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("IDCategoriaFondi", "TINYINT", False, False, False, 0)> _
      Public Property IDCategoriaFondi() As Byte
         Get
            Return _IDCategoriaFondi
         End Get
         Set(ByVal Value As Byte)
            Try
               _IDCategoriaFondi = Value
               OnPropertyChanged("IDCategoriaFondi")
            Catch ex As System.Exception
               Throw New Exception("Error setting IDCategoriaFondi", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Info", "VARCHAR", False, False, True, 30)> _
 Public Property Info() As String
         Get
            Return _Info
         End Get
         Set(ByVal Value As String)
            Try
               If Value Is Nothing Then
                  _Info = Value
                  OnPropertyChanged("Info")
               Else
                  If Value.Length <= 30 Then
                     _Info = Value
                     OnPropertyChanged("Info")
                  Else
                     Throw New OverflowException("Error setting Info, Length of Value is to long. Maximum Length: 30")
                  End If
               End If

            Catch ex As System.Exception
               Throw New Exception("Error setting Info", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("IDObiettivo", "TINYINT", False, False, False, 0)> _
      Public Property IDObiettivo() As Byte
         Get
            Return _IDObiettivo
         End Get
         Set(ByVal Value As Byte)
            Try
               _IDObiettivo = Value
               OnPropertyChanged("IDObiettivo")
            Catch ex As System.Exception
               Throw New Exception("Error setting IDObiettivo", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("IDValutaSecondaria", "TINYINT", False, False, False, 0)> _
      Public Property IDValutaSecondaria() As Byte
         Get
            Return _IDValutaSecondaria
         End Get
         Set(ByVal Value As Byte)
            Try
               _IDValutaSecondaria = Value
               OnPropertyChanged("IDValutaSecondaria")
            Catch ex As System.Exception
               Throw New Exception("Error setting IDValutaSecondaria", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("IDValutaPrimaria", "TINYINT", False, False, False, 0)> _
      Public Property IDValutaPrimaria() As Byte
         Get
            Return _IDValutaPrimaria
         End Get
         Set(ByVal Value As Byte)
            Try
               _IDValutaPrimaria = Value
               OnPropertyChanged("IDValutaPrimaria")
            Catch ex As System.Exception
               Throw New Exception("Error setting IDValutaPrimaria", ex)
            End Try
         End Set
      End Property

      <ColumnMappingAttribute("Emissione", "SMALLDATETIME", False, False, True, 0)> _
      Public Property Emissione() As Nullable(Of DateTime)
         Get
            Return _Emissione
         End Get
         Set(ByVal Value As Nullable(Of DateTime))
            Try
               _Emissione = Value
               OnPropertyChanged("Emissione")
            Catch ex As System.Exception
               Throw New Exception("Error setting Emissione", ex)
            End Try
         End Set
      End Property

#End Region

#Region "INotifyPropertyChanged"
      Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

      Protected Sub OnPropertyChanged(ByVal field As String)
         RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(field))
      End Sub
#End Region

#Region "INotifyPropertyChanging"
      Public Event PropertyChanging(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangingEventArgs) Implements System.ComponentModel.INotifyPropertyChanging.PropertyChanging

      Protected Sub OnPropertyChanging(ByVal field As String)
         RaiseEvent PropertyChanging(Me, New PropertyChangingEventArgs(field))
      End Sub
#End Region
   End Class
End Namespace 